-- name: [CS] Shadow The Hedgehog
-- description: A Template for Character Select to build off of when making your own pack!\n\n\\#ff7777\\This Pack requires Character Select\nto use as a Library!

--[[
    API Documentation for Character Select can be found below:
    https://github.com/Squishy6094/character-select-coop/wiki/API-Documentation

    Use this if you're curious on how anything here works >v<
]]
ACT_SHADOW_RIFLE= allocate_mario_action(ACT_FLAG_ATTACKING)
local TEXT_MOD_NAME = "Shadow The Hedgehog"
audioStream = audio_stream_load("sonic0001.mp3")
-- Stops mod from loading if Character Select isn't on
if not _G.charSelectExists then
    djui_popup_create("\\#ffffdc\\\n"..TEXT_MOD_NAME.."\nRequires the Character Select Mod\nto use as a Library!\n\nPlease turn on the Character Select Mod\nand Restart the Room!", 6)
    return 0
end
E_MODEL_LASER = smlua_model_util_get_id("laser_geo")
local E_MODEL_SHAD = smlua_model_util_get_id("shadow_geo") -- Located in "actors"
E_MODEL_BIKE = smlua_model_util_get_id("bike_geo")
local TEX_CUSTOM_SHAD_ICON = get_texture_info("Shadow_life") -- Located in "textures"
local TEX_CUSTOM_CHAOSICON = get_texture_info("chaosemerald") -- Located in "textures"

-- All Located in "sound"
local VOICETABLE_SHADOWTH = {
    [CHAR_SOUND_ATTACKED] = 'shadhurt.ogg',
    [CHAR_SOUND_DOH] = 'shadhmph.ogg',
    [CHAR_SOUND_DROWNING] = 'shaddie.ogg',
    [CHAR_SOUND_DYING] = 'shaddie.ogg',
    [CHAR_SOUND_GROUND_POUND_WAH] = 'shadhmph!.ogg',
    [CHAR_SOUND_HAHA] = 'shadhere i come (2).ogg',
    [CHAR_SOUND_HAHA_2] = 'shadhere i come (2).ogg',
    [CHAR_SOUND_HERE_WE_GO] = 'shadultimate victory.ogg',
    [CHAR_SOUND_HOOHOO] = 'shadtrick2.ogg',
    [CHAR_SOUND_MAMA_MIA] = 'shaddie.ogg',
    [CHAR_SOUND_OKEY_DOKEY] = 'shaddissapoint.ogg',
    [CHAR_SOUND_ON_FIRE] = 'shadwhat.ogg',
    [CHAR_SOUND_OOOF] = 'shadhurt.ogg',
    [CHAR_SOUND_OOOF2] = 'shadhurt.ogg',
    [CHAR_SOUND_PUNCH_HOO] = 'shadrest.ogg',
    [CHAR_SOUND_PUNCH_WAH] = 'shadplaytime.ogg',
    [CHAR_SOUND_PUNCH_YAH] = 'shadit all starts.ogg',
    [CHAR_SOUND_SO_LONGA_BOWSER] = 'shadcreep.ogg',
    [CHAR_SOUND_TWIRL_BOUNCE] = 'shadcoolest.ogg',
    [CHAR_SOUND_WAAAOOOW] = 'shadfall.ogg',
    [CHAR_SOUND_WAH2] = 'shadsomersault.ogg',
    [CHAR_SOUND_WHOA] = 'shadsomersault.ogg',
    [CHAR_SOUND_YAHOO] = 'shadtrick2.ogg',
    [CHAR_SOUND_YAHOO_WAHA_YIPPEE] = 'shadcoolest.ogg',
    [CHAR_SOUND_YAH_WAH_HOO] = 'shadtrick.ogg',
    [CHAR_SOUND_YAWNING] = 'shadnot interested.ogg',
    [CHAR_SOUND_HELLO] = 'shadChaosControl.ogg',
    
}

-- All Located in "actors"
--local CAPTABLE_CHAR = {
  --  normal = smlua_model_util_get_id("custom_model_cap_normal_geo"),
    --wing = smlua_model_util_get_id("custom_model_cap_wing_geo"),
    --metal = smlua_model_util_get_id("custom_model_cap_metal_geo"),
    --metalWing = smlua_model_util_get_id("custom_model_cap_wing_geo"),
--}

local E_MODEL_CUSTOM_CHAOS = smlua_model_util_get_id("emerald_geo") -- Located in "actors"

local PALETTE_SHADOW = {
    [PANTS]  = "ffffff",
    [SHIRT]  = "ffffff",
    [GLOVES] = "ffffff",
    [SHOES]  = "ff0000",
    [HAIR]   = "151A2D",
    [SKIN]   = "D2B48C",
    [CAP]    = "ff0000",
    [EMBLEM] = "fffffff",
}

--[[
-- All Located in "textures"
local healthMeter = {
    label = {
        left = get_texture_info("template-hp-back-left"),
        right = get_texture_info("template-hp-back-right"),
    },
    pie = {
        [1] = get_texture_info("template-hp-pie-1"),
        [2] = get_texture_info("template-hp-pie-2"),
        [3] = get_texture_info("template-hp-pie-3"),
        [4] = get_texture_info("template-hp-pie-4"),
        [5] = get_texture_info("template-hp-pie-5"),
        [6] = get_texture_info("template-hp-pie-6"),
        [7] = get_texture_info("template-hp-pie-7"),
        [8] = get_texture_info("template-hp-pie-8"),
    }
}
]]

--[[
    Note: If there are some functionalities you don't care
    to add such as palettes, you can freely remove the function
    for it, the only function you require is character_add
]]

local CSloaded = false
local function on_character_select_load()
    edgyhedgy = _G.charSelect.character_add("Shadow The Hedgehog", {"The Ultimate Life Form, Push Y button to use Chaos Control! This will", " teleport you to many objects, and push X to summon your bike!"}, "SEGA/Chaorrin", {r = 255, g = 200, b = 200}, E_MODEL_SHAD, CT_MARIO, TEX_CUSTOM_SHAD_ICON)
    _G.charSelect.character_add_voice(E_MODEL_SHAD, VOICETABLE_SHADOWTH)
    _G.charSelect.character_add_celebration_star(E_MODEL_SHAD, E_MODEL_CUSTOM_CHAOS, TEX_CUSTOM_CHAOSICON)
    _G.charSelect.character_add_palette_preset(E_MODEL_SHAD, PALETTE_SHADOW)
    --_G.charSelect.character_add_health_meter(CT_CHAR, healthMeter)


    CSloaded = true
end

ANIMTABLE_SHADOW = {

     [CHAR_ANIM_BEND_KNESS_RIDING_SHELL] = "shad_bike",
     [CHAR_ANIM_RIDING_SHELL] = "shad_bike",
     [CHAR_ANIM_JUMP_RIDING_SHELL] = "shad_bike",
    [CHAR_ANIM_START_RIDING_SHELL]= "shad_bike",}

local function on_character_sound(m, sound)
    if not CSloaded then return end
    if _G.charSelect.character_get_voice(m) == VOICETABLE_SHADOWTH then return _G.charSelect.voice.sound(m, sound) end
end

local function on_character_snore(m)
    if not CSloaded then return end
    if _G.charSelect.character_get_voice(m) == VOICETABLE_SHADOWTH then return _G.charSelect.voice.snore(m) end
end
function shad_update(m)
    -- patch in custom animations
    if gPlayerSyncTable[m.playerIndex].chaospower then

       
    local anim = ANIMTABLE_SHADOW[m.marioObj.header.gfx.animInfo.animID]
    if anim ~= nil then

        smlua_anim_util_set_animation(m.marioObj, anim)
    end
    if (m.controller.buttonPressed & X_BUTTON) ~= 0 and (m.action & ACT_FLAG_SWIMMING) ==  0 and spawned ~= true    then
        spawned = true
        spawn_sync_object(
            id_bhvKoopaShell,
            E_MODEL_BIKE,
            m.pos.x, m.pos.y, m.pos.z,nil)
   

    end
 
if     m.riddenObj  then 
        audio_stream_play(audioStream, false, .5);
        stop_shell_music()
     
        m.forwardVel = 100
      
      
       end
       
    end


if  m.action == ACT_WALKING then
    spawned = false


    audio_stream_pause(audioStream);  

    
end
 



   

end

hook_event(HOOK_MARIO_UPDATE, shad_update)
hook_event(HOOK_ON_MODS_LOADED, on_character_select_load)
hook_event(HOOK_CHARACTER_SOUND, on_character_sound)
hook_event(HOOK_MARIO_UPDATE, on_character_snore)